// DigitalSignature.h: interface for the CDigitalSignature class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIGITALSIGNATURE_H__FD86484E_6974_4D99_A23C_33D312C163DD__INCLUDED_)
#define AFX_DIGITALSIGNATURE_H__FD86484E_6974_4D99_A23C_33D312C163DD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "Macrodef.h"

#include "Key.h"

class CDigitalSignature : public CTimLib
{
public:
	CDigitalSignature(void);
	virtual ~CDigitalSignature(void);

	CDigitalSignature( const CDigitalSignature& rhs );
	CDigitalSignature& operator=( const CDigitalSignature& rhs );
	CDigitalSignature& operator=( const CKey& rhs );

public:
	bool IncludeInTim() { return m_bIncludeInTim; }
	void IncludeInTim( bool bIncludeInTim ) { m_bIncludeInTim = bIncludeInTim; m_bChanged = true; }

	virtual unsigned int KeySize(){ return (m_pKey ? m_pKey->KeySize() : 0); }
	virtual void KeySize( unsigned int uiKeySize );

	t_stringList& RsaDigSList(){ return m_RsaDigSList; }

	tstring& RsaDigS();
	tstring& RsaDigSPacked();
	void ResetRsaDigS();
	t_stringList& ECDigS_RList(){ return m_ECDigS_RList; }
	tstring& ECDigS_R();
	tstring& ECDigS_RPacked();
	void ResetECDigS_R();

	t_stringList& ECDigS_SList(){ return m_ECDigS_SList; }
	tstring& ECDigS_S();
	tstring& ECDigS_SPacked();
	void ResetECDigS_S();

	PLAT_DS toPlatDs();
	bool FromPlatDs( PLAT_DS& stDs );

	bool DigSFromArray( UINT* pDigSAry, unsigned int size );
	bool DigSToArray( UINT* pDigSAry, unsigned int size );
	void DiscardAll();
    
	void WriteBLF(tofstream& ofs,bool bECflag);
    
	CKey*& DSKey() { return m_pKey; }
	void DSKey( CKey* pKey ) { delete m_pKey; m_pKey = pKey; }

	bool IsChanged();
	void Changed( bool bSet );
private:
	bool	m_bIncludeInTim;
	bool    m_bChanged;
	tstring	m_sDsaAlgorithmId;

	tstring  m_sRsaDigS;         // temp - do not store
	t_stringList m_RsaDigSList;
	tstring  m_sECDigS_R;         // temp - do not store
	t_stringList m_ECDigS_RList;
	tstring  m_sECDigS_S;         // temp - do not store
	t_stringList m_ECDigS_SList;

	CKey*   m_pKey;
};

typedef list<CDigitalSignature*>           t_DigitalSignatureList;
typedef list<CDigitalSignature*>::iterator t_DigitalSignatureListIter;



#endif // !defined(AFX_DIGITALSIGNATURE_H__FD86484E_6974_4D99_A23C_33D312C163DD__INCLUDED_)
