/******************************************************************************
 *
 *  (C)Copyright 2005 - 2009 Marvell. All Rights Reserved.
 *  
 *  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MARVELL.
 *  The copyright notice above does not evidence any actual or intended 
 *  publication of such source code.
 *  This Module contains Proprietary Information of Marvell and should be
 *  treated as Confidential.
 *  The information in this file is provided for the exclusive use of the 
 *  licensees of Marvell.
 *  Such users have the right to use, modify, and incorporate this code into 
 *  products for purposes authorized by the license agreement provided they 
 *  include this notice and the associated copyright notice with any such
 *  product. 
 *  The information in this file is provided "AS IS" without warranty.
 *
 ******************************************************************************/

#ifndef __IMAGEDESCRITION_H__1
#define __IMAGEDESCRITION_H__1
#include "Macrodef.h"
#include "TimLib.h"

class  CImageDescription : public CTimLib
{
public:
	CImageDescription();
	virtual ~CImageDescription(void);

   // copy constructor
	CImageDescription( const CImageDescription& rhs );
	// assignment operator
	CImageDescription& operator=( const CImageDescription& rhs );

	tstring& ImageId() ;           // Get Image ID
	void ImageId( tstring& sImageId );   // Set Image ID
   // below is same as above comment
	tstring& ImageIdTag();
	void ImageIdTag( tstring& sTag );

	tstring& NextImageId();
	void NextImageId( tstring& sImageId );

	tstring& NextImageIdTag();
	void NextImageIdTag( tstring& sImageIdTag );

	void FlashEntryAddress( tstring& sAddress );
	tstring& FlashEntryAddress() ;

	void FlashEntryAddressInSector( tstring& sAddressInSector );
	tstring& FlashEntryAddressInSector() ;

	void FlashEntryAddressInBytes( tstring& sAddressInBytes );
	tstring& FlashEntryAddressInBytes() ;
	void LoadAddress( tstring& sAddress ) ;
	tstring& LoadAddress() ;

	void ImageSizeToCrc( tstring& sImageSizeToCrc ) ;
	tstring& ImageSizeToCrc() ;

	void ImageFilePath( tstring& sImageFilePath ) ;
	tstring& ImageFilePath() ;

	void HashAlgorithmId( tstring& sHashAlgorithmId ) ;
	tstring& HashAlgorithmId() ;

	void PartitionNumber( unsigned int uiPartitionNumber ) ;
	unsigned int PartitionNumber() ;

	void ImageSizeToHash( unsigned int uiImageSizeToHash ) ;
	unsigned int ImageSizeToHash() ;
	tstring ImageSizeToHashStr(){return m_sOrgHashSizeStr;}
	void ImageSizeToHashStr(tstring sHashSize){m_sOrgHashSizeStr = sHashSize;}

	void ImageSize( unsigned int uiImageSize ) ;
	unsigned int ImageSize() ;

	void ImageEraseSize( unsigned int uiImageEraseSize ) ;
	unsigned int ImageEraseSize() ;
    
	void ImageEraseSizeString( tstring& strImageEraseSize );
	tstring& ImageEraseSizeString() ;

	tstring& Imagefiletype() ;
	void Imagefiletype( tstring& sImagefiletype )  ;

 
	void Reset();


	bool IsChanged();
	void Changed( bool bSet );

	bool IsImgEnable();
	void SetImageEnable(bool bImgstate) ;

 	TIMINCLUDEDTYPE_T GetImgIncluedInTim();
 	void SetImgIncluedInTim(TIMINCLUDEDTYPE_T IncluedInTim);

	unsigned int Hash[MAX_HASH_IN_BITS/32];		// Reserve 512 bits for the largest hash

private:
	tstring	m_sImageId;
	tstring	m_sImageIdTag;
	tstring	m_sNextImageId;    
	tstring	m_sNextImageIdTag;       //IDTag is the hex of ID
	tstring	m_sFlashEntryAddress;
	tstring	m_sFlashEntryAddrInBytes;
	tstring  m_sFlashEntryAddressInSector;
	tstring	m_sLoadAddress;
	tstring	m_sImageSizeToCrc;
	tstring	m_sImageFilePath;         //    Image file path
	tstring	m_sHashAlgorithmId;
	tstring  m_sOrgHashSizeStr;
	unsigned int m_uiImageSize;
	unsigned int m_uiImageSizeToHash;
	unsigned int m_uiPartitionNumber;
	unsigned int m_uiImageEraseSize;
	tstring  m_sImageEraseSizeStr;
	tstring  m_sImagefiletype;
    tstring  m_sConvertFilename;
	bool m_bChanged;
	bool m_bImgEnable;
	TIMINCLUDEDTYPE_T m_eIncluedInTim;
};

#endif