/******************************************************************************
 *
 *  (C)Copyright 2005 - 2009 Marvell. All Rights Reserved.
 *  
 *  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MARVELL.
 *  The copyright notice above does not evidence any actual or intended 
 *  publication of such source code.
 *  This Module contains Proprietary Information of Marvell and should be
 *  treated as Confidential.
 *  The information in this file is provided for the exclusive use of the 
 *  licensees of Marvell.
 *  Such users have the right to use, modify, and incorporate this code into 
 *  products for purposes authorized by the license agreement provided they 
 *  include this notice and the associated copyright notice with any such
 *  product. 
 *  The information in this file is provided "AS IS" without warranty.
 *
 ******************************************************************************/

#pragma once

#include "Macrodef.h"
#include <list>
#include <iterator>
#include "TimLib.h"
using namespace std;
typedef list<tstring*>           t_stringList;
typedef list<tstring*>::iterator t_stringListIter;

// ExtReservedData definitions
const tstring sExtendedReservedData = _T("Extended_Reserved_Data");
const tstring sEndExtendedReservedData = _T("End_Extended_Reserved_Data");

// lock Enable? => (0x434c4b45) (CLKE),
const tstring sClockEnable = _T("Clock_Enable");
const tstring sEndClockEnable = _T("End_Clock_Enable");
const tstring sCLKE = _T("0x434c4b45");
// DR Geometry? => (0x44445247) (DDRG),
const tstring sDDRGeometry = _T("DDR_Geometry");
const tstring sEndDDRGeometry = _T("End_DDR_Geometry");
const tstring sDDRG =_T("0x44445247");
// DR Timing?   => (0x44445254) (DDRT),
const tstring sDDRTiming = _T("DDR_Timing");
const tstring sEndDDRTiming = _T("End_DDR_Timing");
const tstring sDDRT =_T("0x44445254");
// DR Custom?   => (0x44445243) (DDRC),
const tstring sDDRCustom = _T("DDR_Custom");
const tstring sDDRC = _T("0x44445243");
// requency?    => (0x46524551) (FREQ),
const tstring sFrequency = _T("Frequency");
const tstring sFREQ = _T("0x46524551");
// oltages?     => (0x564f4c54) (VOLT)
const tstring sVoltages = _T("Voltages");
const tstring sVOLT = _T("0x564f4c54");
// "Configure Memory Control  => (0x434d4343) (CCMC)
const tstring sConfigMemoryControl = _T("Configure_Memory_Control");
const tstring sCMCC = _T("0x434d4343");
// "Trust Zone => (0x545A4944) (TZID)
const tstring sTrustZone = _T("Trust_Zone");
const tstring sTZID = _T("0x545A4944");
// "Trust Zone Regid=> (0x545A4F4E) (TZON)
const tstring sTrustZoneRegid = _T("Trust_Zone_Regid");
const tstring sTZON = _T("0x545A4F4E");
// "OP Div ==> (0x4F504456) (OPDV)
const tstring sOpDiv = _T("OpDiv");
const tstring sOPDV = _T("0x4F504456");
// "OP Mode ==> (0x4D4F4445) (MODE)
const tstring sOpMode = _T("OpMode");
const tstring sMODE = _T("0x4D4F4445");

#pragma warning ( disable : 4251 ) // Disable warning messages
class  CReservedPackageData: public CTimLib
{
public:
	CReservedPackageData(void);
	virtual ~CReservedPackageData(void);

	// copy constructor
	CReservedPackageData( const CReservedPackageData& rhs );
	// assignment operator
	CReservedPackageData& operator=( const CReservedPackageData& rhs );
    void DiscardAll();
	bool IsChanged() ;
	void Changed( bool bSet );

	tstring& PackageId() ;
	void PackageId( const tstring& sPackageId );

	tstring& PackageIdTag() ;
	void PackageIdTag( const tstring& sPackageIdTag );

	int Size();

	t_stringList& PackageDataList();
	void PackageDataList(t_stringList& PackageDataList);
	void PackageCommentList(t_stringList& PackageCommentList);
	t_stringList& PackageCommentList();
	t_PairstringList& PackageRecordsList() ;

	int DataBlock( tstring& sDataBlock );
  
	void DiscardDataAndComments();
	void AddData( tstring* psData, tstring *psComment );
	void AddRecordsData( tstring* psData, tstring *psRecorsComment );
    void DeleteData( tstring* psData );
private:
	void PredefinedPackageComments( int idx, tstring *psComment );
private:
	tstring	m_sPackageId;
	tstring	m_sPackageIdTag;
	t_stringList m_PackageDataList;
	t_stringList m_PackageCommentList;
	t_PairstringList m_PackageRecordsList;
	int m_size;
	bool m_bChanged;
	
};

typedef list<CReservedPackageData*>           t_ReservedDataList;
typedef list<CReservedPackageData*>::iterator t_ReservedDataListIter;



