/******************************************************************************
 *
 *  (C)Copyright 2005 - 2009 Marvell. All Rights Reserved.
 *  
 *  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MARVELL.
 *  The copyright notice above does not evidence any actual or intended 
 *  publication of such source code.
 *  This Module contains Proprietary Information of Marvell and should be
 *  treated as Confidential.
 *  The information in this file is provided for the exclusive use of the 
 *  licensees of Marvell.
 *  Such users have the right to use, modify, and incorporate this code into 
 *  products for purposes authorized by the license agreement provided they 
 *  include this notice and the associated copyright notice with any such
 *  product. 
 *  The information in this file is provided "AS IS" without warranty.
 *
 ******************************************************************************/
//#pragma once
#ifndef __TIMLIB_H
#define __TIMLIB_H

#include "listdefine.h"
#include "Tim.h"
#include "Typedef.h"
#include <stdio.h> 
#if !defined (LINUX)
#include <tchar.h>
#else
#include <stdio.h>
#endif
#include "Macrodef.h"

#pragma warning ( disable : 4275 ) // Disable warning messages

class  CTimLib
{
public:
	CTimLib(void);
	virtual ~CTimLib(void);

	bool GetDWord (tifstream& ifs, TCHAR *szString, unsigned int* pValue);
	bool GetSValue (tifstream& ifs, const TCHAR*szString, tstring& sValue, bool bErrMsg = false );
	bool GetFieldValue (tstring& sLine, tstring& sField, DWORD& dwValue);
	bool GetFieldValue (tstring& sLine, tstring& sField, tstring& sValue);
    bool GetDoubleFieldValue(tstring& sLine, tstring& sRightValue,tstring& sLeftValue); // get the right and left value of "="
	bool CheckGetSValue (tifstream& ifs, TCHAR *szString, tstring& sValue);

	unsigned int Translate (const TCHAR *pValue);
	unsigned int Translate (tstring sValue);
	UINT64 TranslateEx (tstring sValue);
	void RemoveComment(tstring &sValue,tstring &sComment) ;
    void RemovePresuffixes(tstring &sValue);
	bool FillDataArrays (tifstream& ifs,DWORD *dwArray,int iSize); 

	void Endian_Convert (UINT_T x,UINT_T *y);
	UINT32_T CheckSum (unsigned char *Address, UINT_T length);

	bool CheckImageOverlap(t_ImagesList& Images, unsigned int BootFlashSign, TCHAR *msg_error);
    tifstream& GetNextLine( tifstream& ifs, tstring& sLine );
    tofstream& WriteLine( tofstream& ofs, tstring& sLine );
	

	//bool GetQWord (tifstream& ifs, char *szString, UINT64 *pValue);
	//unsigned __int64 TranslateQWord (const char *pValue);

	void PrependPathIfNone( tstring& sFilePath );
	void PrependPathEx(TCHAR *pszPath,TCHAR *pszBlfPath);
	tstring QuotedFilePath( tstring& sFilePath );
	tstring& HexFormattedAscii( unsigned int iNum );
	tstring& HexFormattedAscii64( UINT64 iNum );
	tstring& HexFormattedAscii40( UINT64 iNum );
	tstring HexAsciiToText( const tstring& sHexAscii );
	tstring& HexFormat10Address(tstring& sAddress10bit);
	tstring& HexFormat8Address(tstring& sAddress8bit);
//	bool TrimAndSkipLine( tstring& sLine );

	tstring& TextToHexFormattedAscii( tstring& sText );

	// std::tstring helpers
	bool IsAlpha( const tstring& instring );
	tstring ToLower( const tstring& instring, bool bHexNum = false );
	tstring ToUpper( const tstring& instring, bool bHexNum = false );
    void TextToHexFormattedAscii( tstring& sRet, tstring& sText );

	/*static*/ tstring TrimWS( tstring& sValue );
	/*static */tstring TrimLeadingWS( tstring& sValue );
	/*static */tstring TrimTrailingWS( tstring& sValue );

	// array and list helpers
	/*static*/ bool ToArrayFromList( t_stringList& List, unsigned int* pUintAry, unsigned int size );
	/*static */bool ToListFromArray( unsigned int* pUintAry, t_stringList& List, unsigned int size );
	/*static */bool ResizeList( t_stringList& List, unsigned int size, bool& bChanged );
	
};


#endif
